/*
 * Generated automatically from ./ncp2222.py
 * Do not edit this file manually, as all changes will be lost.
 */


/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <glib.h>
#include "packet.h"
#include "conversation.h"
#include "ptvcursor.h"
#include "packet-ncp-int.h"
    
static int hf_ncp_func = -1;
static int hf_ncp_length = -1;
static int hf_ncp_subfunc = -1;
static int hf_ncp_completion_code = -1;
static int hf_ncp_connection_status = -1;
	
static int hf_ncp_property_name = -1;
static int hf_ncp_num_bytes = -1;
static int hf_ncp_object_flags = -1;
static int hf_ncp_property_type = -1;
static int hf_ncp_connection_number = -1;
static int hf_ncp_object_id = -1;
static int hf_ncp_object_name = -1;
static int hf_ncp_file_offset = -1;
static int hf_ncp_buffer_size = -1;
static int hf_ncp_object_security = -1;
static int hf_ncp_property_data = -1;
static int hf_ncp_property_has_more_segments = -1;
static int hf_ncp_file_size = -1;
static int hf_ncp_property_segment = -1;
static int hf_ncp_object_has_properites = -1;
static int hf_ncp_unknown_byte = -1;
static int hf_ncp_task_number = -1;
static int hf_ncp_object_type = -1;
static int hf_ncp_file_handle = -1;
static int hf_ncp_max_bytes = -1;
static int hf_ncp_job_type = -1;
static int hf_ncp_object_name1 = -1;

static const value_string ncp_object_flags_vals[] = {
	{ 0x00,	"Dynamic object" },
	{ 0x01,	"Static object" },
	{ 0x00,	NULL },
};


static const value_string ncp_property_type_vals[] = {
	{ 0x00,	"Static item" },
	{ 0x01,	"Dynamic item" },
	{ 0x02,	"Static set" },
	{ 0x03,	"Dynamic set" },
	{ 0x00,	NULL },
};


static const value_string ncp_object_security_vals[] = {
	{ 0x00,	"Anyone can read or modify the object" },
	{ 0x01,	"Client logged into the file server can read the object" },
	{ 0x02,	"Client logged into the file server with the object's name, type and password can read the object" },
	{ 0x03,	"Client with supervisor equivalence can read the object" },
	{ 0x04,	"Only the operating system can read the object" },
	{ 0x10,	"Client logged into the file server can modify the object" },
	{ 0x20,	"Client logged into the file server with the object's name, type and password can modify the object" },
	{ 0x30,	"Client with supervisor equivalence can modify the object" },
	{ 0x40,	"Only the operating system can modify the object" },
	{ 0x00,	NULL },
};


static const value_string ncp_property_has_more_segments_vals[] = {
	{ 0x00,	"Is last segment" },
	{ 0xff,	"More segments are available" },
	{ 0x00,	NULL },
};


static const value_string ncp_object_has_properites_vals[] = {
	{ 0x00,	"No properties" },
	{ 0xff,	"One or more properties" },
	{ 0x00,	NULL },
};


static const value_string ncp_object_type_vals[] = {
	{ 0x0000,	"Unknown" },
	{ 0x0001,	"User" },
	{ 0x0002,	"User group" },
	{ 0x0003,	"Print queue" },
	{ 0x0004,	"NetWare file server" },
	{ 0x0005,	"Job server" },
	{ 0x0006,	"Gateway" },
	{ 0x0007,	"Print server" },
	{ 0x0008,	"Archive queue" },
	{ 0x0009,	"Archive server" },
	{ 0x000a,	"Job queue" },
	{ 0x000b,	"Administration" },
	{ 0x0021,	"NAS SNA gateway" },
	{ 0x0026,	"Remote bridge server" },
	{ 0x0027,	"TCP/IP gateway" },
	{ 0x0000,	NULL },
};


void
proto_register_ncp2222(void)
{

	static hf_register_info hf[] = {
	{ &hf_ncp_func,
	{ "Function", "ncp.func", FT_UINT8, BASE_HEX, NULL, 0x0, "" }},

	{ &hf_ncp_length,
	{ "Packet Length", "ncp.length", FT_UINT16, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_subfunc,
	{ "SubFunction", "ncp.subfunc", FT_UINT8, BASE_HEX, NULL, 0x0, "" }},

	{ &hf_ncp_completion_code,
	{ "Completion Code", "ncp.completion_code", FT_UINT8, BASE_HEX, NULL, 0x0, "" }},

	{ &hf_ncp_connection_status,
	{ "Connection Status", "ncp.connection_status", FT_UINT8, BASE_DEC, NULL, 0x0, "" }},
	
	{ &hf_ncp_property_name,
	{ "Property Name", "ncp.property_name", FT_UINT_STRING, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_num_bytes,
	{ "Number of Bytes", "ncp.num_bytes", FT_UINT16, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_flags,
	{ "Object Flags", "ncp.object_flags", FT_UINT8, BASE_HEX, VALS(ncp_object_flags_vals), 0x0, "" }},

	{ &hf_ncp_property_type,
	{ "Property Type", "ncp.property_type", FT_UINT8, BASE_HEX, VALS(ncp_property_type_vals), 0x0, "" }},

	{ &hf_ncp_connection_number,
	{ "Connection Number", "ncp.connection_number", FT_UINT32, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_id,
	{ "Object ID", "ncp.object_id", FT_UINT32, BASE_HEX, NULL, 0x0, "" }},

	{ &hf_ncp_object_name,
	{ "Object Name", "ncp.object_name", FT_UINT_STRING, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_file_offset,
	{ "File Offset", "ncp.file_offset", FT_UINT32, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_buffer_size,
	{ "Buffer Size", "ncp.buffer_size", FT_UINT16, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_security,
	{ "Object Security", "ncp.object_security", FT_UINT8, BASE_HEX, VALS(ncp_object_security_vals), 0x0, "" }},

	{ &hf_ncp_property_data,
	{ "Property Data", "ncp.property_data", FT_BYTES, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_property_has_more_segments,
	{ "Property Has More Segments", "ncp.property_has_more_segments", FT_UINT8, BASE_HEX, VALS(ncp_property_has_more_segments_vals), 0x0, "" }},

	{ &hf_ncp_file_size,
	{ "File Size", "ncp.file_size", FT_UINT32, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_property_segment,
	{ "Property Segment", "ncp.property_segment", FT_UINT8, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_has_properites,
	{ "Object Has Properties", "ncp.object_has_properites", FT_UINT8, BASE_HEX, VALS(ncp_object_has_properites_vals), 0x0, "" }},

	{ &hf_ncp_unknown_byte,
	{ "Unknown Byte", "ncp.unknown_byte", FT_UINT8, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_task_number,
	{ "Task Number", "ncp.task_number", FT_UINT32, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_type,
	{ "Object Type", "ncp.object_type", FT_UINT16, BASE_HEX, VALS(ncp_object_type_vals), 0x0, "" }},

	{ &hf_ncp_file_handle,
	{ "File Handle", "ncp.file_handle", FT_BYTES, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_max_bytes,
	{ "Maximum Number of Bytes", "ncp.max_bytes", FT_UINT16, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_job_type,
	{ "Job Type", "ncp.job_type", FT_UINT16, BASE_DEC, NULL, 0x0, "" }},

	{ &hf_ncp_object_name1,
	{ "Object Name", "ncp.object_name1", FT_STRING, BASE_DEC, NULL, 0x0, "" }},

	};

		proto_register_field_array(proto_ncp, hf, array_length(hf));
	}
	
/* Error 0x0001 not used: Transaction tracking is available */
/* Error 0x0002 not used: Ok. The data has been written */
/* Error 0x0100 not used: One or more of the ConnectionNumbers in the send list are invalid */
/* Error 0x0101 not used: Invalid space limit */
/* Error 0x0102 not used: Insufficient disk space */
/* Error 0x0103 not used: Queue server cannot add jobs */
/* Error 0x0104 not used: Out of disk space */
/* Error 0x0105 not used: Semaphore overflow */
/* Error 0x0200 not used: One or more clients in the send list are not logged in */
/* Error 0x0201 not used: Queue server cannot attach */
/* Error 0x0300 not used: One or more clients in the send list are not accepting messages */
/* Error 0x0400 not used: Client already has message */
/* Error 0x0401 not used: Queue server cannot service job */
/* Error 0x7e00 not used: NCP failed boundary check */
/* Error 0x8000 not used: Lock fail */
/* Error 0x8100 not used: A file handle could not be allocated by the file server */
/* Error 0x8200 not used: Unauthorized to open the file */
/* Error 0x8300 not used: Unable to read/write the volume. Possible bad sector on the file server */
/* Error 0x8400 not used: Unauthorized to create the directory */
/* Error 0x8401 not used: Unauthorized to create the file */
/* Error 0x8500 not used: Unauthorized to delete the specified file */
/* Error 0x8501 not used: Unauthorized to overwrite an existing file in this directory */
/* Error 0x8700 not used: An unexpected character was encountered in the filename */
/* Error 0x8900 not used: Unauthorized to search this directory */
/* Error 0x8a00 not used: Unauthorized to delete this directory */
/* Error 0x8b00 not used: Unauthorized to rename a file in this directory */
/* Error 0x8c00 not used: No set privileges */
/* Error 0x8c01 not used: Unauthorized to modify a file in this directory */
/* Error 0x8c02 not used: Unauthorized to change the restriction on this volume */
/* Error 0x8d00 not used: Some of the affected files are in use by another client */
/* Error 0x8d01 not used: The affected file is in use */
/* Error 0x8e00 not used: All of the affected files are in use by another client */
/* Error 0x8f00 not used: Some of the affected files are read-only */
/* Error 0x9000 not used: An attempt to modify a read-only volume occurred */
/* Error 0x9001 not used: All of the affected files are read-only */
/* Error 0x9100 not used: Some of the affected files already exist */
/* Error 0x9200 not used: Directory with the new name already exists */
/* Error 0x9201 not used: All of the affected files already exist */
/* Error 0x9400 not used: Unauthorized to write to this file */
/* Error 0x9500 not used: The affected file is detached */
/* Error 0x9601 not used: No alloc space for message */
/* Error 0x9800 not used: The affected volume is not mounted */
/* Error 0x9801 not used: The volume associated with VolumeNumber is not mounted */
/* Error 0x9802 not used: The resulting voume does not exist */
/* Error 0x9803 not used: The destination volume is not mounted */
/* Error 0x9a00 not used: The request attempted to rename the affected file to another volume */
/* Error 0x9b00 not used: DirHandle is not associated with a valid directory path */
/* Error 0x9b01 not used: A resulting directory handle is not associated with a valid directory path */
/* Error 0x9b02 not used: The directory associated with DirHandle does not exist */
/* Error 0x9b03 not used: Bad directory handle */
/* Error 0x9c00 not used: The resulting path is not valid */
/* Error 0x9c01 not used: The resulting file path is not valid */
/* Error 0x9c02 not used: The resulting directory path is not valid */
/* Error 0x9c03 not used: Invalid path */
/* Error 0x9d00 not used: A directory handle was not available for allocation */
/* Error 0x9e00 not used: The name of the directory does not conform to a legal name for this name space */
/* Error 0x9e01 not used: The new directory name does not conform to a legal name for this name space */
/* Error 0x9f00 not used: The request attempted to delete a directory that is in use by another client */
/* Error 0xa000 not used: The request attempted to delete a directory that is not empty */
/* Error 0xa100 not used: An unrecoverable error occured on the affected directory */
/* Error 0xa200 not used: The request attempted to read from a file region that is physically locked */
/* Error 0xa400 not used: Invalid directory rename attempted */
/* Error 0xbf00 not used: Requests for this name space are not valid on this volume */
/* Error 0xc000 not used: Unauthorized to retrieve accounting data */
/* Error 0xc100 not used: The ACCOUNT_BALANCE property does not exist */
/* Error 0xc200 not used: The object has exceeded its credit limit */
/* Error 0xc300 not used: Too many holds have been placed against this account */
/* Error 0xc400 not used: The client account has been disabled */
/* Error 0xc500 not used: Access to the account has been denied because of intruder detection */
/* Error 0xc501 not used: Login lockout */
/* Error 0xc600 not used: The caller does not have operator priviliges */
/* Error 0xc601 not used: The client does not have operator priviliges */
/* Error 0xd200 not used: A queue server is not associated with this queue */
/* Error 0xd202 not used: No queue server */
/* Error 0xd400 not used: The queue is full and cannot accept another request */
/* Error 0xd500 not used: A job does not exist in this queue */
/* Error 0xd501 not used: No queue job */
/* Error 0xd600 not used: The file server does not allow unencrypted passwords */
/* Error 0xd700 not used: Bad account */
/* Error 0xd701 not used: The old and new password strings are identical */
/* Error 0xd702 not used: The job is currently being serviced */
/* Error 0xd703 not used: The queue is currently servicing a job */
/* Error 0xd900 not used: The file server cannot accept another connection as it has reached its limit */
/* Error 0xd902 not used: Station is not a server */
/* Error 0xda00 not used: Attempted to login to the file server during a restricted time period */
/* Error 0xdb00 not used: Attempted to login to the file server from an unauthorized workstation or network */
/* Error 0xdb02 not used: Maximum queue servers */
/* Error 0xde00 not used: Attempted to login to the file server with an incorrect password */
/* Error 0xdf00 not used: Attempted to login to the file server with a password that has expired */
/* Error 0xe700 not used: No disk track */
/* Error 0xe800 not used: Write to group */
/* Error 0xe900 not used: The object is already a member of the group property */
/* Error 0xea00 not used: No such member */
/* Error 0xea01 not used: The bindery object is not a member of the set */
/* Error 0xea02 not used: Non-existent member */
/* Error 0xeb00 not used: The property is not a set property */
/* Error 0xec00 not used: No such set */
/* Error 0xed00 not used: Property exists */
/* Error 0xed01 not used: The property already exists */
/* Error 0xed02 not used: An attempt was made to create a bindery object property that already exists */
/* Error 0xee00 not used: The object already exists */
/* Error 0xee01 not used: The bindery object already exists */
/* Error 0xef00 not used: Illegal name */
/* Error 0xef02 not used: Invalid name */
/* Error 0xf001 not used: An illegal wildcard was detected in ObjectName */
/* Error 0xf101 not used: Bindery security */
/* Error 0xf102 not used: Invalid bindery security */
/* Error 0xf200 not used: Unauthorized to read from this object */
/* Error 0xf300 not used: Unauthorized to rename this object */
/* Error 0xf400 not used: Unauthorized to delete this object */
/* Error 0xf401 not used: No object delete privileges */
/* Error 0xf402 not used: Unauthorized to delete this queue */
/* Error 0xf500 not used: Unauthorized to create this object */
/* Error 0xf501 not used: No object create */
/* Error 0xf600 not used: No property delete */
/* Error 0xf601 not used: Unauthorized to delete the property of this object */
/* Error 0xf602 not used: Unauthorized to delete this property */
/* Error 0xf700 not used: Unauthorized to create this property */
/* Error 0xf701 not used: No property create privilege */
/* Error 0xf800 not used: Unauthorized to write to this property */
/* Error 0xfa00 not used: Temporary remap error */
/* Error 0xfb00 not used: No such property */
/* Error 0xfb01 not used: The file server does not support this request */
/* Error 0xfb03 not used: The PASSWORD property does not exist for this bindery object */
/* Error 0xfc00 not used: The message queue cannot accept another message */
/* Error 0xfc01 not used: The trustee associated with ObjectId does not exist */
/* Error 0xfc03 not used: The bindery object associated with ObjectID does not exist */
/* Error 0xfc04 not used: A bindery object does not exist that matches */
/* Error 0xfc05 not used: The specified queue does not exist */
/* Error 0xfc06 not used: No such object */
/* Error 0xfc07 not used: The queue associated with ObjectID does not exist */
/* Error 0xfd00 not used: Bad station number */
/* Error 0xfd01 not used: The connection associated with ConnectionNumber is not active */
/* Error 0xfd02 not used: Lock collision */
/* Error 0xfd03 not used: Transacktion tracking is disabled */
/* Error 0xfe00 not used: I/O failure */
/* Error 0xfe02 not used: A file with the specified name already exists in this directory */
/* Error 0xfe03 not used: No more restrictions were found */
/* Error 0xfe04 not used: The file server was unable to lock the file within the specified time limit */
/* Error 0xfe05 not used: The file server was unable to lock all files within the specified time limit */
/* Error 0xfe06 not used: The bindery object associated with ObjectID is not a valid trustee */
/* Error 0xfe07 not used: Directory locked */
/* Error 0xfe08 not used: Bindery locked */
/* Error 0xfe09 not used: Invalid semaphore name length */
/* Error 0xfe0a not used: The file server was unable to complete the operation within the specified time limit */
/* Error 0xfe0b not used: Transaction restart */
/* Error 0xff01 not used: Lock error */
/* Error 0xff02 not used: File not found */
/* Error 0xff03 not used: The file not found or cannot be unlocked */
/* Error 0xff04 not used: Record not found */
/* Error 0xff05 not used: The logical record was not found */
/* Error 0xff06 not used: The printer associated with PrinterNumber does not exist */
/* Error 0xff07 not used: No such printer */
/* Error 0xff08 not used: Unable to complete the request */
/* Error 0xff09 not used: Unauthorized to change privileges of this trustee */
/* Error 0xff0a not used: No files matching the search criteria were found */
/* Error 0xff0b not used: A file matching the search criteria was not found */
/* Error 0xff0c not used: Verification failed */
/* Error 0xff0d not used: Object associated with ObjectID is not a manager */
/* Error 0xff0e not used: Invalid initial semaphore value */
/* Error 0xff0f not used: The semaphore handle is not valid */
/* Error 0xff10 not used: SemaphoreHandle is not associated with a valid sempahore */
/* Error 0xff11 not used: Invalid semaphore handle */
/* Error 0xff12 not used: Transaction tracking is not available */
/* Error 0xff13 not used: The transaction has not yet been written to disk */
/* Error 0xff14 not used: Directory already exists */
/* Error 0xff15 not used: The file already exists and the deletion flag was not set */
/* Error 0xff16 not used: No matching files or directories were found */
/* Error 0xff17 not used: A file or directory matching the search criteria was not found */
/* Error 0xff18 not used: The file already exists */
/* Error 0xff19 not used: No files found */


/* Error strings. */
static const char *ncp_errors[] = {
	/* 00 (0x0000) */ "Ok",
	/* 01 (0xff00) */ "Failure",
	/* 02 (0x9600) */ "The file server has run out of memory to service this request",
	/* 03 (0xef01) */ "Illegal characters in ObjectName field",
	/* 04 (0xf000) */ "A wildcard was detected in a field that does not support wildcards",
	/* 05 (0xfc02) */ "The specified bindery object does not exist",
	/* 06 (0xfe01) */ "The files containing the bindery on the file server are locked",
	/* 07 (0x8800) */ "Invalid file handle",
	/* 08 (0x9300) */ "Unauthorized to read from this file",
	/* 09 (0xec01) */ "The set property does not exist",
	/* 10 (0xf100) */ "The client does not have the rights to access this bindery object",
	/* 11 (0xf900) */ "Unauthorized to read this property",
	/* 12 (0xfb02) */ "The specified property does not exist",
	/* 13 (0x9900) */ "The file server has run out of directory space on the affected volume",
	/* 14 (0xd000) */ "Queue error",
	/* 15 (0xd100) */ "The queue does not exist",
	/* 16 (0xd201) */ "A queue server is not associated with the selected queue",
	/* 17 (0xd300) */ "No queue rights",
	/* 18 (0xd401) */ "The queue associated with ObjectId is full and cannot accept another request",
	/* 19 (0xd502) */ "The job associated with JobNumber does not exist in this queue",
	/* 20 (0xd601) */ "No job right",
	/* 21 (0xd704) */ "Queue servicing",
	/* 22 (0xd800) */ "Queue not active",
	/* 23 (0xd901) */ "The client is not security equivalent to one of the objects in the Q_SERVERS group property of the target queue",
	/* 24 (0xda01) */ "Queue halted",
	/* 25 (0xdb01) */ "The queue cannot attach another queue server",
};

/* Group not used: accounting = Accounting */
/* Group not used: afp = AFP */
/* Group not used: auditing = Auditing */
/* Group not used: directory = Directory */
/* Group not used: extended = Extended Attribute */
/* Group not used: fileserver = File Server */
/* Group not used: message = Message */
/* Group not used: migration = Data Migration */
/* Group not used: misc = Miscellaneous */
/* Group not used: name = Name Space */
/* Group not used: nds = NetWare Directory */
/* Group not used: print = Print */
/* Group not used: tss = Transaction Tracking */


/* Group strings. */
static const char *ncp_groups[] = {
	/* 00 (sync) */ "Synchronization",
	/* 01 (bindery) */ "Bindery",
	/* 02 (queue) */ "Queue",
	/* 03 (connection) */ "Connection",
	/* 04 (file) */ "File",
};

/* PTVC records. These are re-used to save space. */
static const ptvc_record ncp_0x1735_request[] = {
	{ &hf_ncp_object_type, 2, FALSE },
	{ &hf_ncp_object_name, 1, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x1735_reply[] = {
	{ &hf_ncp_object_id, 4, FALSE },
	{ &hf_ncp_object_type, 2, FALSE },
	{ &hf_ncp_object_name1, 48, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x1737_request[] = {
	{ &hf_ncp_object_id, 4, FALSE },
	{ &hf_ncp_object_type, 2, FALSE },
	{ &hf_ncp_object_name, 1, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x1737_reply[] = {
	{ &hf_ncp_object_id, 4, FALSE },
	{ &hf_ncp_object_type, 2, FALSE },
	{ &hf_ncp_object_name1, 48, FALSE },
	{ &hf_ncp_object_flags, 1, FALSE },
	{ &hf_ncp_object_security, 1, FALSE },
	{ &hf_ncp_object_has_properites, 1, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x173d_request[] = {
	{ &hf_ncp_object_type, 2, FALSE },
	{ &hf_ncp_object_name, 1, FALSE },
	{ &hf_ncp_property_segment, 1, FALSE },
	{ &hf_ncp_property_name, 1, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x173d_reply[] = {
	{ &hf_ncp_property_data, 128, FALSE },
	{ &hf_ncp_property_has_more_segments, 1, FALSE },
	{ &hf_ncp_property_type, 1, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x177c_request[] = {
	{ &hf_ncp_object_id, 4, FALSE },
	{ &hf_ncp_job_type, 2, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x177c_reply[] = {
	{ &hf_ncp_connection_number, 4, FALSE },
	{ &hf_ncp_task_number, 4, FALSE },
	{ &hf_ncp_object_id, 4, FALSE },
	{ &hf_ncp_object_id, 4, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x21_request[] = {
	{ &hf_ncp_buffer_size, 2, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x42_request[] = {
	{ &hf_ncp_file_handle, 6, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x47_reply[] = {
	{ &hf_ncp_file_size, 4, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x48_request[] = {
	{ &hf_ncp_unknown_byte, 1, FALSE },
	{ &hf_ncp_file_handle, 6, FALSE },
	{ &hf_ncp_file_offset, 4, FALSE },
	{ &hf_ncp_max_bytes, 2, FALSE },
	{ NULL, 0, 0 }
};

static const ptvc_record ncp_0x48_reply[] = {
	{ &hf_ncp_num_bytes, 2, FALSE },
	{ NULL, 0, 0 }
};

/* Error-Equivalency Tables. These are re-used to save space. */
static const error_equivalency ncp_0x2_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x1735_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x96, 2 }, /* 0x9600 */
	{ 0xef, 3 }, /* 0xef01 */
	{ 0xf0, 4 }, /* 0xf000 */
	{ 0xfc, 5 }, /* 0xfc02 */
	{ 0xfe, 6 }, /* 0xfe01 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x1737_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x96, 2 }, /* 0x9600 */
	{ 0xef, 3 }, /* 0xef01 */
	{ 0xfc, 5 }, /* 0xfc02 */
	{ 0xfe, 6 }, /* 0xfe01 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x173d_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x88, 7 }, /* 0x8800 */
	{ 0x93, 8 }, /* 0x9300 */
	{ 0x96, 2 }, /* 0x9600 */
	{ 0xec, 9 }, /* 0xec01 */
	{ 0xf0, 4 }, /* 0xf000 */
	{ 0xf1, 10 }, /* 0xf100 */
	{ 0xf9, 11 }, /* 0xf900 */
	{ 0xfb, 12 }, /* 0xfb02 */
	{ 0xfc, 5 }, /* 0xfc02 */
	{ 0xfe, 6 }, /* 0xfe01 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x177c_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x99, 13 }, /* 0x9900 */
	{ 0xd0, 14 }, /* 0xd000 */
	{ 0xd1, 15 }, /* 0xd100 */
	{ 0xd2, 16 }, /* 0xd201 */
	{ 0xd3, 17 }, /* 0xd300 */
	{ 0xd4, 18 }, /* 0xd401 */
	{ 0xd5, 19 }, /* 0xd502 */
	{ 0xd6, 20 }, /* 0xd601 */
	{ 0xd7, 21 }, /* 0xd704 */
	{ 0xd8, 22 }, /* 0xd800 */
	{ 0xd9, 23 }, /* 0xd901 */
	{ 0xda, 24 }, /* 0xda01 */
	{ 0xdb, 25 }, /* 0xdb01 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x18_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x47_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x88, 7 }, /* 0x8800 */
	{ 0x00, -1 }
};

static const error_equivalency ncp_0x48_errors[] = {
	{ 0x00, 0 }, /* 0x0000 */
	{ 0x88, 7 }, /* 0x8800 */
	{ 0x93, 8 }, /* 0x9300 */
	{ 0xff, 1 }, /* 0xff00 */
	{ 0x00, -1 }
};

#define SUBFUNC 0xff
#define NOSUB   0x00
/* ncp_record structs for packets */
static const ncp_record ncp_packets[] = {
	{ 0x02, 0x00, NOSUB, "File Release Lock", 	0 /* sync */,
		NULL, NULL, NULL, NULL,
		ncp_0x2_errors },

	{ 0x17, 0x35, SUBFUNC, "Get Bindery Object ID", 	1 /* bindery */,
		ncp_0x1735_request, NULL, ncp_0x1735_reply, NULL,
		ncp_0x1735_errors },

	{ 0x17, 0x37, SUBFUNC, "Scan Bindery Object", 	1 /* bindery */,
		ncp_0x1737_request, NULL, ncp_0x1737_reply, NULL,
		ncp_0x1737_errors },

	{ 0x17, 0x3d, SUBFUNC, "Read Property Value", 	1 /* bindery */,
		ncp_0x173d_request, NULL, ncp_0x173d_reply, NULL,
		ncp_0x173d_errors },

	{ 0x17, 0x7c, SUBFUNC, "Service Queue Job", 	2 /* queue */,
		ncp_0x177c_request, NULL, ncp_0x177c_reply, NULL,
		ncp_0x177c_errors },

	{ 0x18, 0x00, NOSUB, "End of Job", 	3 /* connection */,
		NULL, NULL, NULL, NULL,
		ncp_0x18_errors },

	{ 0x19, 0x00, NOSUB, "Logout", 	3 /* connection */,
		NULL, NULL, NULL, NULL,
		ncp_0x18_errors },

	{ 0x21, 0x00, NOSUB, "Negotiate Buffer Size", 	3 /* connection */,
		ncp_0x21_request, NULL, ncp_0x21_request, NULL,
		ncp_0x18_errors },

	{ 0x42, 0x00, NOSUB, "Close File", 	4 /* file */,
		ncp_0x42_request, NULL, NULL, NULL,
		ncp_0x2_errors },

	{ 0x47, 0x00, NOSUB, "Get Current Size of File", 	4 /* file */,
		ncp_0x42_request, NULL, ncp_0x47_reply, NULL,
		ncp_0x47_errors },

	{ 0x48, 0x00, NOSUB, "Read From A File", 	4 /* file */,
		ncp_0x48_request, NULL, ncp_0x48_reply, NULL,
		ncp_0x48_errors },

	{ 0, 0, 0, NULL }
};

/* ncp funcs that require a subfunc */
static const guint8 ncp_func_requires_subfunc[] = {
	0x17,
	0
};

#include "packet-ncp2222.inc"
